## xchpst 0.2.1

=== Makefile ===
# SPDX-License-Identifier: MIT
# SPDX-FileCopyrightText: (c) Copyright 2024 Andrew Bower <andrew@bower.uk>

VERSION ?= 0.2.1
name := xchpst

prefix ?= /usr/local
#CFLAGS ?= -g
CFLAGS ?= -g -O2
CFLAGS += -MMD -MP \
	  -Wall -Wextra -Werror \
	  -Wno-missing-field-initializers \
	  -std=c2x \
	  -D_GNU_SOURCE \
	  -DPROG_NAME=$(name) \
	  -DPROG_VERSION=$(VERSION) \
	  -DINST_PREFIX=$(prefix)
LDLIBS = -lcap
INSTALL = install
LN = ln -f
DEP = $(wildcard *.d)
prefix ?= /usr

OBJS = xchpst.o options.o usrgrp.o caps.o env.o join.o rootfs.o mount.o
ALT_EXES = chpst softlimit envdir pgrphack setuidgid envuidgid setlock

.PHONY: all clean install

all: $(name) $(ALT_EXES) chpst.compat

-include $(DEP)

$(name): $(OBJS)

$(ALT_EXES): $(name)
	$(LN) $< $@

# chpst.compat is a build of 'chpst' that does not accept xchpst extensions
chpst.compat: chpst.o $(filter-out xchpst.o,$(OBJS))
	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@

chpst.o: xchpst.c
	$(COMPILE.c) $(OUTPUT_OPTION) -DPROG_DEFAULT=chpst -DSTRICT_CHPST_COMPAT $<

clean:
	$(RM) $(name) $(OBJS) $(DEP) $(ALT_EXES) chpst.o chpst.compat

install:
	$(INSTALL) -m 755 -D -t $(DESTDIR)$(prefix)/bin               $(name)
#	$(INSTALL) -m 755 -D -t $(DESTDIR)$(prefix)/bin               $(ALT_EXES)
#	$(INSTALL) -m 755 -D -t $(DESTDIR)$(prefix)/bin               chpst.compat
	$(INSTALL) -m 644 -D -t $(DESTDIR)$(prefix)/share/man/man8    $(name).8
	$(INSTALL) -m 644 -D -t $(DESTDIR)$(prefix)/share/doc/$(name) extra/xchpst-funcs.sh

=== debian/changelog ===
xchpst (0.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #1092288)

 -- Andrew Bower <andrew@bower.uk>  Fri, 10 Jan 2025 23:48:59 +0000

=== debian/control ===
Source: xchpst
Section: admin
Priority: optional
Maintainer: Andrew Bower <andrew@bower.uk>
Build-Depends: debhelper-compat (= 13), libcap-dev
Standards-Version: 4.7.0
Homepage: https://gitlab.com/abower/xchpst
Vcs-Browser: https://salsa.debian.org/debian/xchpst
Vcs-Git: https://salsa.debian.org/debian/xchpst.git
Rules-Requires-Root: no

Package: xchpst
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Enhances: runit
Description: eXtended CHange Process STate
 xchpst is an extended rewrite of runit's chpst that adds control of Linux
 namespaces and capabilities. This tool can be used to launch system services
 from runscripts with hardening options including isolated and transient
 parts of the filesystem hierarchy and a read-only system.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic -Werror

include /usr/share/dpkg/pkg-info.mk

export prefix=/usr
export VERSION=$(DEB_VERSION_UPSTREAM)

%:
	dh $@

=== debian/tests/control ===
Tests: ro-sys
Restrictions: isolation-machine

Tests: private-tmp
Depends: @, bash
Restrictions: isolation-machine

Tests: pid-ns
Restrictions: isolation-machine, needs-root

## xchpst 0.3.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: MIT
-# SPDX-FileCopyrightText: (c) Copyright 2024 Andrew Bower <andrew@bower.uk>
+# SPDX-FileCopyrightText: (c) Copyright 2024,2025 Andrew Bower <andrew@bower.uk>
 
-VERSION ?= 0.2.1
+VERSION ?= 0.3.0
 name := xchpst
 
 prefix ?= /usr/local

=== debian/changelog ===
xchpst (0.3.0-1) unstable; urgency=medium

  * New upstream version
  * Switch from dpkg-divert to alternatives
  * d/control: xchpst requires Linux
  * d/rules: pass full debian version through to build
  * d/test: add 5 more autopkgtests

 -- Andrew Bower <andrew@bower.uk>  Wed, 29 Jan 2025 22:16:28 +0000

## xchpst 0.4.1

=== Makefile ===
# SPDX-License-Identifier: MIT
# SPDX-FileCopyrightText: (c) Copyright 2024,2025 Andrew Bower <andrew@bower.uk>

VERSION ?= 0.4.0
name := xchpst

prefix ?= /usr/local
#CFLAGS ?= -g
CFLAGS ?= -g -O2
CFLAGS += -MMD -MP \
	  -Wall -Wextra -Werror \
	  -Wno-missing-field-initializers \
	  -std=c2x \
	  -D_GNU_SOURCE \
	  -DPROG_NAME=$(name) \
	  -DPROG_VERSION=$(VERSION) \
	  -DINST_PREFIX=$(prefix)
LDLIBS = -lcap
INSTALL = install
LN = ln -f
DEP = $(wildcard *.d)
prefix ?= /usr

OBJS = xchpst.o options.o usrgrp.o caps.o env.o join.o rootfs.o mount.o \
  precreate.o
ALT_EXES = chpst softlimit envdir pgrphack setuidgid envuidgid setlock

.PHONY: all clean install

all: $(name) $(ALT_EXES)

-include $(DEP)

$(name): $(OBJS)

$(ALT_EXES): $(name)
	$(LN) $< $@

clean:
	$(RM) $(name) $(OBJS) $(DEP) $(ALT_EXES) chpst.o chpst.compat

install:
	$(INSTALL) -m 755 -D -t $(DESTDIR)$(prefix)/bin               $(name)
#	$(INSTALL) -m 755 -D -t $(DESTDIR)$(prefix)/bin               $(ALT_EXES)
	$(INSTALL) -m 644 -D -t $(DESTDIR)$(prefix)/share/man/man8    $(name).8
	$(INSTALL) -m 644 -D -t $(DESTDIR)$(prefix)/share/doc/$(name) extra/xchpst-funcs.sh

=== debian/changelog ===
xchpst (0.4.1-1) unstable; urgency=medium

  [ Andrew Bower ]
  * New upstream version
  * eliminate race hazard in lock test

 -- Andrew Bower <andrew@bower.uk>  Sun, 16 Feb 2025 20:14:08 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Rules-Requires-Root: no
 
 Package: xchpst
-Architecture: any
+Architecture: linux-any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Enhances: runit

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,12 @@
 include /usr/share/dpkg/pkg-info.mk
 
 export prefix=/usr
-export VERSION=$(DEB_VERSION_UPSTREAM)
+export VERSION=$(DEB_VERSION)
 
 %:
 	dh $@
+
+override_dh_auto_install:
+	dh_auto_install
+	mv debian/xchpst/usr/bin/xchpst debian/xchpst/usr/bin/xchpst.real
+	mv debian/xchpst/usr/share/man/man8/xchpst.8 debian/xchpst/usr/share/man/man8/xchpst.real.8

## xchpst 0.5.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: MIT
 # SPDX-FileCopyrightText: (c) Copyright 2024,2025 Andrew Bower <andrew@bower.uk>
 
-VERSION ?= 0.4.0
+VERSION ?= 0.5.0
 name := xchpst
 
 prefix ?= /usr/local

=== debian/changelog ===
xchpst (0.5.0-1) unstable; urgency=medium

  [ Andrew Bower ]
  * New upstream release
    - add ability to specify options via a file
    - add new hardening options
    - declare stable option interface
  * d/control: update S-V to 4.7.2, no changes needed

 -- Andrew Bower <andrew@bower.uk>  Sat, 15 Mar 2025 19:41:42 +0000

## xchpst 0.6.1

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: MIT
 # SPDX-FileCopyrightText: (c) Copyright 2024,2025 Andrew Bower <andrew@bower.uk>
 
-VERSION ?= 0.5.0
+VERSION ?= 0.6.1
 name := xchpst
 
 prefix ?= /usr/local
@@ -9,7 +9,6 @@
 CFLAGS ?= -g -O2
 CFLAGS += -MMD -MP \
 	  -Wall -Wextra -Werror \
-	  -Wno-missing-field-initializers \
 	  -std=c2x \
 	  -D_GNU_SOURCE \
 	  -DPROG_NAME=$(name) \
@@ -43,4 +42,3 @@
 	$(INSTALL) -m 755 -D -t $(DESTDIR)$(prefix)/bin               $(name)
 #	$(INSTALL) -m 755 -D -t $(DESTDIR)$(prefix)/bin               $(ALT_EXES)
 	$(INSTALL) -m 644 -D -t $(DESTDIR)$(prefix)/share/man/man8    $(name).8
-	$(INSTALL) -m 644 -D -t $(DESTDIR)$(prefix)/share/doc/$(name) extra/xchpst-funcs.sh

=== debian/changelog ===
xchpst (0.6.1-1) unstable; urgency=medium

  [ Andrew Bower ]
  * New upstream release
    - extended man page, with systemd unit porting guidance
    - additional options
    - unused compat script removed
  * maintscripts: remove redundant update-alternatives approach

 -- Andrew Bower <andrew@bower.uk>  Fri, 21 Mar 2025 21:47:41 +0000

## xchpst 0.6.2

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: MIT
 # SPDX-FileCopyrightText: (c) Copyright 2024,2025 Andrew Bower <andrew@bower.uk>
 
-VERSION ?= 0.6.1
+VERSION ?= 0.6.2
 name := xchpst
 
 prefix ?= /usr/local

=== debian/changelog ===
xchpst (0.6.2-1) unstable; urgency=medium

  * New upstream release
    - tweak to fix manpages.d.o table rendering
    - drop user later in sequence except with user namespaces

 -- Andrew Bower <andrew@bower.uk>  Sat, 12 Apr 2025 11:12:09 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Andrew Bower <andrew@bower.uk>
 Build-Depends: debhelper-compat (= 13), libcap-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://gitlab.com/abower/xchpst
 Vcs-Browser: https://salsa.debian.org/debian/xchpst
 Vcs-Git: https://salsa.debian.org/debian/xchpst.git

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4
opts="mode=git,pgpmode=gittag" \
 https://gitlab.com/abower/xchpst.git/ refs/tags/v([\d\.]+)

## xchpst 0.7.0

=== Makefile ===
# SPDX-License-Identifier: MIT
# SPDX-FileCopyrightText: (c) Copyright 2024,2025 Andrew Bower <andrew@bower.uk>

# Tunables

VERSION ?= 0.7.0
prefix ?= /usr/local
CFLAGS ?= -g -O2
# For zero dependencies, but no capabilities control, invoke with NO_CAP=1

# The rest

name := xchpst
CFLAGS += -MMD -MP \
	  -Wall -Wextra -Werror \
	  -std=c2x \
	  -D_GNU_SOURCE \
	  -DPROG_NAME=$(name) \
	  -DPROG_VERSION=$(VERSION) \
	  -DINST_PREFIX=$(prefix)
ifndef NO_CAP
LDLIBS = -lcap
else
CFLAGS += -DNO_CAP
endif
INSTALL = install
LN = ln -sf
DEP = $(wildcard *.d)

OBJS = xchpst.o options.o usrgrp.o env.o join.o rootfs.o mount.o \
  precreate.o
ifndef NO_CAP
OBJS += caps.o
endif

bindir = $(DESTDIR)$(prefix)/bin

ALT_EXES = chpst softlimit envdir pgrphack setuidgid envuidgid setlock \
  applyuidgid \
  setuidgid-fromenv

.PHONY: all clean install

all: $(name) $(ALT_EXES)

-include $(DEP)

$(name): $(OBJS)

$(ALT_EXES) $(addprefix $(bindir)/,$(ALT_EXES)): $(name)
	$(LN) $< $@

clean:
	$(RM) $(name) $(OBJS) $(DEP) $(ALT_EXES) chpst.o

install:
	$(INSTALL) -m 755 -D -t $(bindir)                          $(name)
	$(INSTALL) -m 644 -D -t $(DESTDIR)$(prefix)/share/man/man8 $(name).8

install-extra: install $(addprefix $(bindir)/,$(ALT_EXES))

=== debian/changelog ===
xchpst (0.7.0-1) unstable; urgency=medium

  * New upstream release
    - extended and fixed daemontools family emulation support
    - extended support for supplementary groups
    - fixed --new-root implementation that tidies up old root
  * Update metadata for moved upstream Gitlab namespace
  * d/watch: convert to version 5 format
  * d/control: remove redundant Rules-Requires-Root

 -- Andrew Bower <andrew@bower.uk>  Sat, 13 Sep 2025 11:56:48 +0100

## xchpst 0.7.1

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # Tunables
 
-VERSION ?= 0.7.0
+VERSION ?= 0.7.1
 prefix ?= /usr/local
 CFLAGS ?= -g -O2
 # For zero dependencies, but no capabilities control, invoke with NO_CAP=1

=== debian/changelog ===
xchpst (0.7.1-1) unstable; urgency=medium

  * New upstream release
    - bugfixes, code quality improvements and documentation updates

 -- Andrew Bower <andrew@bower.uk>  Sat, 20 Sep 2025 08:03:20 +0100

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,9 @@
 Maintainer: Andrew Bower <andrew@bower.uk>
 Build-Depends: debhelper-compat (= 13), libcap-dev
 Standards-Version: 4.7.2
-Homepage: https://gitlab.com/abower/xchpst
+Homepage: https://gitlab.com/init-tools/xchpst
 Vcs-Browser: https://salsa.debian.org/debian/xchpst
 Vcs-Git: https://salsa.debian.org/debian/xchpst.git
-Rules-Requires-Root: no
 
 Package: xchpst
 Architecture: linux-any

## xchpst 0.7.2

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # Tunables
 
-VERSION ?= 0.7.1
+VERSION ?= 0.7.2
 prefix ?= /usr/local
 CFLAGS ?= -g -O2
 # For zero dependencies, but no capabilities control, invoke with NO_CAP=1

=== debian/changelog ===
xchpst (0.7.2-1) unstable; urgency=medium

  * New upstream release
    - fix wrap around in capabilities set for cap >= 32
    - allow empty capability lists
  * d/control: remove redundant Priority: optional field

 -- Andrew Bower <andrew@bower.uk>  Mon, 27 Oct 2025 06:47:23 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: xchpst
 Section: admin
-Priority: optional
 Maintainer: Andrew Bower <andrew@bower.uk>
 Build-Depends: debhelper-compat (= 13), libcap-dev
 Standards-Version: 4.7.2

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic -Werror

include /usr/share/dpkg/pkg-info.mk

export prefix=/usr
export VERSION=$(DEB_VERSION)

%:
	dh $@

=== debian/tests/control ===
Tests: version
Restrictions: superficial

Tests: scheduler, argv0, lock
Depends: @, bash, busybox

Tests: ro-sys private-tmp
Depends: @, bash
Restrictions: isolation-machine

Tests: pid-ns
Restrictions: isolation-machine, needs-root

# Restrictions cannot guarantee an appropriate testbed for this test.
Tests: user-ns+chdir
Restrictions: isolation-machine, needs-root, flaky

=== debian/watch ===
Version: 5

Source: https://gitlab.com/init-tools/xchpst.git/
Matching-Pattern: refs/tags/v([\d\.]+)
Mode: git
Pgpmode: gittag

## xchpst 0.8.1

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # Tunables
 
-VERSION ?= 0.7.2
+VERSION ?= 0.8.0
 prefix ?= /usr/local
 CFLAGS ?= -g -O2
 # For zero dependencies, but no capabilities control, invoke with NO_CAP=1
@@ -12,8 +12,9 @@
 
 name := xchpst
 CFLAGS += -MMD -MP \
+	  -I. \
 	  -Wall -Wextra -Werror \
-	  -std=c2x \
+	  -std=gnu2x \
 	  -D_GNU_SOURCE \
 	  -DPROG_NAME=$(name) \
 	  -DPROG_VERSION=$(VERSION) \
@@ -28,6 +29,7 @@
 DEP = $(wildcard *.d)
 
 OBJS = xchpst.o options.o usrgrp.o env.o join.o rootfs.o mount.o \
+  dirs.o \
   precreate.o
 ifndef NO_CAP
 OBJS += caps.o
@@ -36,6 +38,7 @@
 bindir = $(DESTDIR)$(prefix)/bin
 
 ALT_EXES = chpst softlimit envdir pgrphack setuidgid envuidgid setlock \
+  fghack \
   applyuidgid \
   setuidgid-fromenv
 
@@ -46,6 +49,9 @@
 -include $(DEP)
 
 $(name): $(OBJS)
+
+# Unit tests directory
+test/children: test/children.o $(filter-out xchpst.o,$(OBJS))
 
 $(ALT_EXES) $(addprefix $(bindir)/,$(ALT_EXES)): $(name)
 	$(LN) $< $@

=== debian/changelog ===
xchpst (0.8.1-1) unstable; urgency=medium

  * New upstream release.
  * Convert to dgit-maint-merge(7) workflow.
  * d/README.Debian: remove as added no value.
  * d/control: update S-V to 4.7.3, no changes needed

 -- Andrew Bower <andrew@bower.uk>  Fri, 13 Feb 2026 17:32:24 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Maintainer: Andrew Bower <andrew@bower.uk>
 Build-Depends: debhelper-compat (= 13), libcap-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://gitlab.com/init-tools/xchpst
 Vcs-Browser: https://salsa.debian.org/debian/xchpst
 Vcs-Git: https://salsa.debian.org/debian/xchpst.git

## xchpst 0.8.2

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # Tunables
 
-VERSION ?= 0.8.0
+VERSION ?= 0.8.2
 prefix ?= /usr/local
 CFLAGS ?= -g -O2
 # For zero dependencies, but no capabilities control, invoke with NO_CAP=1

=== debian/changelog ===
xchpst (0.8.2-1) unstable; urgency=medium

  * New upstream release.
    - fix FTBFS with glibc 2.43 (Closes: #1128760)

 -- Andrew Bower <andrew@bower.uk>  Sun, 22 Feb 2026 19:22:54 +0000
